<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="80px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="userId" label="用户ID">
                <el-input v-model="formData.user.nickname"></el-input>
            </el-form-item>
            <el-form-item prop="amount" label="提现金额">
                <el-input-number type="number" v-model="formData.amount"></el-input-number>
            </el-form-item>
            <el-form-item prop="auditTime" label="审核时间">
                <el-date-picker
                    v-model="formData.auditTime"
                    type="datetime"
                    value-format="yyyy-MM-dd HH:mm:ss"
                    placeholder="选择日期时间"
                >
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="payMethod" label="提现方式">
                <el-select v-model="formData.payMethod" clearable filterable placeholder="请选择">
                    <el-option
                        v-for="item in payMethodOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                    >
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="status" label="提现状态">
                <el-select v-model="formData.status" clearable filterable placeholder="请选择">
                    <el-option v-for="item in statusOptions" :key="item.value" :label="item.label" :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="account" label="账号">
                <el-input v-model="formData.account"></el-input>
            </el-form-item>
            <el-form-item prop="realName" label="真实姓名">
                <el-input v-model="formData.realName"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'WithdrawEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('withdraw/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {
                user: {}
            },
            rules: {},
            payMethodOptions: [
                { label: '微信', value: 'WEIXIN' },
                { label: '余额', value: 'YUE' }
            ],
            statusOptions: [
                { label: '提现成功', value: 'SUCCESS' },
                { label: '提现失败', value: 'FAIL' },
                { label: '待处理', value: 'PENDING' }
            ]
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/withdraw/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/withdraw/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
